;#include "scARUco_DLL.as"

#ifndef _SC_ARUCO_DLL_AS_
#define _SC_ARUCO_DLL_AS_

; status
#enum e_ST_START = 0
#enum e_ST_IDLE
#enum e_ST_JOB_START
#enum e_ST_JOB_RUNNING
#enum e_ST_JOB_END
#enum e_ST_ERROR
#enum e_ST_QUIT

; event
#enum e_EV_NOTHING = 0
#enum e_EV_GO_NEXT
#enum e_EV_GO_IDLE
#enum e_EV_GO_ERROR
#enum e_EV_RUNNING
#enum e_EV_GO_END
#enum e_EV_QUIT

; DLL
#uselib "scARUco_DLL.dll"
;#uselib "scARUco_DLL_d.dll"

; int __stdcall scARUco_Create(void)
#cfunc global scARUco_Create "scARUco_Create" 

; int __stdcall scARUco_Destroy(void)
#cfunc global scARUco_Destroy "scARUco_Destroy" 

; int __stdcall scARUco_SaveLog(const char *a_p_filename)
#cfunc global scARUco_SaveLog "scARUco_SaveLog"  str

; int __stdcall scARUco_SetDictionary(const char * a_p_dict_filename)
#cfunc global scARUco_SetDictionary "scARUco_SetDictionary" str

; int __stdcall scARUco_SetCameraParams(const char * a_p_camera_filename)
#cfunc global scARUco_SetCameraParams "scARUco_SetCameraParams" str

; void __stdcall scARUco_CameraParamsResize(unsigned int a_img_width, unsigned int a_img_height)
#cfunc global scARUco_CameraParamsResize "scARUco_CameraParamsResize" int, int

; int __stdcall scARUco_DetectMarkers(const unsigned char *a_p_img_buf_u08, unsigned int a_img_width, unsigned int a_img_height, unsigned int a_line_bytesize)
#cfunc global scARUco_DetectMarkers "scARUco_DetectMarkers" var, int, int, int

; int __stdcall scARUco_GetMarkerInfo(unsigned int a_marker_id, int *a_p_pos_x, int *a_p_pos_y, float *a_p_up_vec_x, float *a_p_up_vec_y, double *a_p_ret_model_view_matrix)
#cfunc global scARUco_GetMarkerInfo "scARUco_GetMarkerInfo" int, var, var, var, var

; int __stdcall scARUco_CameraOpen(int a_camera_id, int a_width, int a_height)
#cfunc global scARUco_CameraOpen "scARUco_CameraOpen" int, int, int

; void __stdcall scARUco_CameraClose(void)
#cfunc global scARUco_CameraClose "scARUco_CameraClose" 

; int __stdcall scARUco_CameraCapture(unsigned char *a_p_img_src_buf_u08, unsigned int a_line_bytesize, unsigned int a_img_width, unsigned int a_img_height)
#cfunc global scARUco_CameraCapture "scARUco_CameraCapture" var, int, int, int

; int __stdcall scARUco_StaticImageOpen(const char *a_p_static_Image_file)
#cfunc global scARUco_StaticImageOpen "scARUco_StaticImageOpen" str

; unsigned int __stdcall scARUco_GetWordNum(void)
#cfunc global scARUco_GetWordNum "scARUco_GetWordNum" 

; const char * __stdcall scARUco_GetWord(unsigned int a_word_id)
#cfunc global scARUco_GetWord "scARUco_GetWord" int

; int __stdcall scARUco_DispImage24(HWND a_hWnd, unsigned char *a_p_ary_pix, int a_dst_ofs_x, int a_dst_ofs_y, int a_dst_width, int a_dst_height, int a_src_width, int a_src_height, int a_flag_flip_h, int a_flag_flip_v, int a_flag_TextOut)
#cfunc global scARUco_DispImage24 "scARUco_DispImage24" int, var, int, int, int, int, int, int, int, int, int

;int __stdcall scARUco_CameraCapture_and_DetectWords(unsigned char *a_p_img_src_buf_u08, unsigned int a_line_bytesize, unsigned int a_img_width, unsigned int a_img_height)
#cfunc global scARUco_CameraCapture_and_DetectWords "scARUco_CameraCapture_and_DetectWords" var, int, int, int

;int __stdcall scARUco_Save_WordImage(const char *a_p_word, const char *a_p_png_filename)
#cfunc global scARUco_Save_WordImage "scARUco_Save_WordImage" str, str

;unsigned int __stdcall scARUco_Set_Keyword(const char *a_p_str_keyword)
#cfunc global scARUco_Set_Keyword "scARUco_Set_Keyword" str

#endif
